Subject: Routing: Implement automatic UUID to object conversion

Description

Fluid already converts objects used as arguments for URls (in forms and action links) to uuids and if no custom route is specified, the
router adds them as regular GET parameters:

http://myhost/foo/bar?baz=297{1954-3904-4824-94c9-3b66d46f2e74

In the example above "baz" is an controller argument of some object type which has been converted to its uuid by Fluid. What we
need now is the counterpart which transparently converts the uuid into an object.

Associated revisions

Revision 27e159ab - 2009-05-15 22:15 - Robert Lemke

Bug fixes during the TYPO3 Bugday on T3DD09

- FLOWS: (MVC) Added typehint to AbstractView / ViewInterface setControllerContext()

- FLOWS: (MVC) Removed the resolving of an object's identity from the Dynamic Route Part handler. This needs to be implemented in a
specialized, dedicated route part handler. Refs #1789

- FLOWS: (MVC) A Route now converts route values which are objects into their uuid.

- FLOWS: (MVC) Fixed a typo in the Router which cause a fatal error (sometimes). setRoutePartConfigurations()

- FLOWS: (MVC) Adapted the tests for the DynamicRoutePart handler

Revision 3c0Obbcb2 - 2009-05-25 17:04 - Robert Lemke

- FLOWS: (MVC) Implemented automatic conversion of UUIDs into objects retrieved from a repository in the Abstract Controller. This is the
counterpart to the object to UUID conversion in the Fluid view helpers. Resolves #1789

- FLOWS3: (MVC) !l Renamed the recently introduced methods queueFlashMessage() and getFlashMessages() to pushFlashMessage() and
popFlashMessages() respectively.

History

#1 - 2008-10-28 12:58 - Karsten Dambekalns

- Priority changed from Should have to Must have
- Target version set to 1.0 alpha 1

#2 - 2009-05-15 21:33 - Robert Lemke

Some code snippets from T3DDO09:

if (strlen($value) === 36 && preg_match('/([a-f0-9]){8}-([a-f0-9]){4}-([a-f0-9]){4}-([a-f0-9]){4}-([a-f0-9]){12}/", $value)) {
http://myhost/foo/bar?baz=297f1954-3904-4824-94c9-3b66d46f2e74

$query = $this->queryFactory->create('F3\Blog\Domain\Model\Blog');
$objects = $query->matching($query->withUUID($value))->execute();
if (count($objects) !== 1) return FALSE;

$value = current($objects);

final public function resolve(array &$routeValues) {
$this->value = NULL;
if ($this->name === NULL || $this->name ===") {
return FALSE;
}
$valueToResolve = $this->findValueToResolve($routeValues);
if (is_object($valueToResolve)) {
$valueToResolve = $this->persistenceManager->getBackend()->getUUIDByObject($valueToResolve);

}

if (\$this->resolveValue($valueToResolve)) {
return FALSE;

}

unset($routeValues[$this->name]);
return TRUE;

#3 - 2009-05-19 12:25 - Robert Lemke
- Assigned To changed from Bastian Waidelich to Robert Lemke

#4 - 2009-05-19 12:29 - Robert Lemke

- Status changed from New to Accepted

#5 - 2009-05-25 17:01 - Robert Lemke

- Subject changed from Routing: RoutePartHandler Service to Routing: Implement automatic UUID to object conversion

#6 - 2009-05-25 18:00 - Robert Lemke
- Status changed from Accepted to Resolved

- % Done changed from 0 to 100

Applied in changeset r2371.
